<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Nama kategori" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'category', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Kategori
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="categories" ref="categoryTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Modul"
                width="200">
                <template slot-scope="scope">
                    <span>{{ translateCategory(scope.row.module) }}</span>
                </template>
            </el-table-column>
            <el-table-column                
                label="Kategori"
                width="150">
                <template slot-scope="scope">                    
                    <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                </template>
            </el-table-column>    
            <el-table-column                
                label="Cover"
                width="150">
                <template slot-scope="scope">
                    <el-image
                    v-if="scope.row.media != null"
                    style="width: 125px; height: 50px"
                    :src="scope.row.media.url.medium"
                    fit="cover">
                    </el-image>

                    <el-image 
                    v-else
                    style="width: 125px; height: 50px">
                        <div slot="error" class="image-slot">
                            NO PHOTO
                        </div>
                    </el-image>
                </template>
            </el-table-column>
            <el-table-column
                label="Sub Kategori Dari"
                width="150">
                <template slot-scope="scope">
                    <span v-if="scope.row.parents != null">{{ scope.row.parents.name }}</span>
                    <span v-else>-</span>
                </template>
            </el-table-column>        
            <el-table-column
                label="Deskripsi"
                width="300">
                <template slot-scope="scope">
                    <span>{{ scope.row.description }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Pemilik"
                width="150"
                v-if="me.role.slug == 'root'">
                <template slot-scope="{row}">
                    <span v-if="row.owner != null">{{ row.owner.profile.fullname }}</span>
                    <span v-else>Default</span>
                </template>
            </el-table-column>            
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">
                    <el-button v-permission="[row, 'category', 'viewown']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'category', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="categoryForm" :model="categoryForm" :rules="categoryRules">
                <aside>
                    <el-alert type="info" description="Menampilkan semua kategori yang dapat dipakai pada semua modul." :closable=false show-icon></el-alert>
                </aside>
                <el-upload
                    class="avatar-uploader uploader-full-width"
                    :action="uploadURL"
                    name="media"
                    with-credentials
                    accept=" .jpg, .jpeg, .png"
                    :headers="{'Authorization': 'Bearer ' + token.access_token}"
                    :limit=1
                    :on-success="handleAvatarSuccess"
                    :before-upload="beforeAvatarUpload"
                    :on-remove="handleRemove">
                    <img v-if="categoryForm.mediaURL" :src="categoryForm.mediaURL" class="avatar">
                    <i v-else class="el-icon-plus avatar-uploader-icon"></i>
                </el-upload>
                <el-row :gutter="20">
                    <el-col :lg="10" :md="24" :xs="24">
                        <el-form-item label="Modul" prop="module">
                            <el-select v-if="me.role.slug != 'root'" v-model="categoryForm.module" placeholder="Pilih modul" class="width-100" ref="module" name="module">
                                <el-option
                                    v-for="item in modules"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                            <el-select v-else v-model="categoryForm.module" placeholder="Pilih modul" class="width-100" ref="module" name="module">
                                <el-option
                                    v-for="item in rootModules"
                                    :key="item.value"
                                    :label="item.label"
                                    :value="item.value">
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="14" :md="24" :xs="24">
                        <el-form-item label="Nama Kategori" prop="name">
                            <el-input ref="name" name="name" v-model="categoryForm.name" placeholder="Nama kategori" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col :lg="10" :md="24" :xs="24">
                        <el-form-item label="Icon" prop="icon">
                            <el-input ref="icon" name="icon" v-model="categoryForm.icon" placeholder="Icon" autocomplete="off" maxlength="255" show-word-limit></el-input>
                        </el-form-item>
                    </el-col>
                    <el-col :lg="14" :md="24" :xs="24">
                        <el-form-item label="Sub Kategori Dari" prop="parent_id">
                            <el-select                                
                                ref="parent_id"
                                name="parent_id"
                                class="width-100"
                                clearable
                                filterable
                                remote
                                :remote-method="getParentCategories"
                                v-model="categoryForm.parent_id"
                                placeholder="Ketik nama kategori"
                                no-data-text="No Data"
                                :loading="parentLoading">
                                <el-option
                                    v-for="item in parentCategories"
                                    :key="item.id"
                                    :label="item.name"
                                    :value="item.id">        
                                </el-option>
                            </el-select>
                        </el-form-item>
                    </el-col>
                </el-row>                
                <el-form-item label="Deskripsi" prop="description">
                    <el-input type="textarea" ref="description" name="description" v-model="categoryForm.description" placeholder="Deskripsi kategori" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'category', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'Category',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        return {
            tableLoading: false,
            dialogLoading: false,
            parentLoading: false,
            filter: {
                keyword: ''
            },
            showDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Kategori',
                create: 'Tambah Kategori'
            },
            modules: [{
                value: 'announcement',
                label: 'Pemberitahuan'
            }, {
                value: 'residentreport',
                label: 'Laporan Warga'
            }, {
                value: 'financialreport',
                label: 'Laporan Keuangan'
            }, {
                value: 'inventory',
                label: 'Inventory'
            }],
            rootModules: [{
                value: 'announcement',
                label: 'Pemberitahuan'
            }, {
                value: 'residentreport',
                label: 'Laporan Warga'
            }, {
                value: 'financialreport',
                label: 'Laporan Keuangan'
            }, {
                value: 'marketplace',
                label: 'Marketplace'
            }, {
                value: 'inventory',
                label: 'Inventory'
            }],
            categoryForm: {
                id: null,
                module: null,
                name: '',
                icon: '',
                description: '',
                parent_id: null,
                archived: false,
                media: null,
                mediaURL: ''
            },
            categoryRules: {
                module: {
                    required: true, message:'Modul wajib dipilih', trigger: 'change'
                },
                name: [{ 
                    required: true, message: 'Nama kategori wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang nama kategori maksimal 255 karakter', trigger: 'blur',
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                icon: [{ 
                    max: 255, message: 'Panjang icon maksimal 255 karakter', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z]{1,255})$/, message: 'Hanya huruf yang diperbolehkan', trigger: 'blur'
                }],
                description: [{ max: 255, message:'Panjang deskripsi maksimal 255 karakter', trigger: 'blur'}]
            },
            uploadURL: ''
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('user', ['me']),
        ...mapGetters('auth', ['token']),
        ...mapGetters('category', [
            'categories',
            'parentCategories',
            'pagination'
        ]),
    },
    created() {
        this.getCategories();
    },
    methods: {
        playSound,
        dateFormat,
        translateCategory(name){
            if(name == 'announcement'){
                return 'Pemberitahuan';
            }else if(name == 'residentreport'){
                return 'Laporan Warga';
            }else if(name == 'financialreport'){
                return 'Laporan Keuangan';
            }else if(name == 'inventory'){
                return 'Inventaris';
            }else if(name == 'marketplace'){
                return 'Marketplace';
            }
        },
        getCategories() {
            this.tableLoading = true;
            this.$store.dispatch('category/getCategories', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        getParentCategories(q) {
            if(q.length >= 3){
                this.parentLoading = true;

                let params = {q:q};

                if(this.categoryForm.module != null){
                    params.module = this.categoryForm.module;
                }

                this.$store.dispatch('category/getParentCategories', params).then(() => {
                    this.parentLoading = false;
                });
            }
        },
        handleSearch(){
            this.tableLoading = true;
            this.$store.dispatch('category/getCategories', {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;        
            this.uploadURL = 'api.ringsatu.id/v1/media/tmp';  
            this.$nextTick(() => {
                this.$refs['categoryForm'].clearValidate();
            });
        },
        handleEdit(category){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.uploadURL = 'api.ringsatu.id/v1/media/category/'+category.id;
            this.categoryForm.id = category.id;
            this.categoryForm.media = category.media != null ? category.media.id : null;
            this.categoryForm.module = category.module;
            this.categoryForm.name = category.name;
            this.categoryForm.icon = category.icon;
            this.categoryForm.description = category.description;  
            this.categoryForm.archived = category.archived;
            this.categoryForm.mediaURL = category.media ? category.media.url.large : '';
            this.$nextTick(() => {
                this.$refs['categoryForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.categoryForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'category/addCategory';
                        payload = {
                            media: this.categoryForm.media,
                            module: this.categoryForm.module,
                            name: this.categoryForm.name,
                            icon: this.categoryForm.icon,
                            description: this.categoryForm.description,
                            parent: this.categoryForm.parent_id
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'category/editCategory';
                        payload = {
                            id: this.categoryForm.id,
                            module: this.categoryForm.module,
                            name: this.categoryForm.name,
                            icon: this.categoryForm.icon,
                            description: this.categoryForm.description,
                            parent: this.categoryForm.parent_id,
                            archived: this.categoryForm.archived
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(category){
            this.$confirm('Anda mencoba untuk menghapus data kategori, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('category/deleteCategory', {
                    id: category.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.categoryForm = {
                id: null,
                module: null,
                name: '',
                icon: '',
                description: '',
                parent_id: null,
                media: null,
                mediaURL: ''
            }
        },
        handleAvatarSuccess(res) {
            this.categoryForm.media = res.data.media.id;
            this.categoryForm.mediaURL = res.data.media.url.original;
        },
        beforeAvatarUpload(file) {
            if (['image/jpeg', 'image/png'].indexOf(file.type) < 0) {
                this.$message.error('Hanya image dengan tipe file JPG/JPEG dan PNG yang diperbolehkan.');
                return false;
            }
            if (file.size > (8 * 1024 * 1024)) {
                this.$message.error('Ukuran file tidak boleh lebih dari 8MB.');
                return false;
            }
            return true;
        },
        handleRemove(){
            let action = '';
            let params = {};

            if(this.dialogStatus == 'create'){
                action = 'media/deleteMediaTmp';
                params.id = this.categoryForm.media;
            }else{
                action = 'media/deleteMedia';
                params.id = this.categoryForm.media;
                params.endpoint = 'category';
            }

            this.$store.dispatch(action, params).then((response) => {
                if('errors' in response){
                    let error = parseError(response.errors);
                    this.$message.error({
                        message: error.messages
                    });
                }else{
                    this.categoryForm.mediaURL = null;
                    this.$message.success({
                        message: response.message
                    });
                }

                this.playSound();
            });
        }
    }

}
</script>
